local skin_path = "weapon_skins/"
local icon_path = "textures/pd2/blackmarket/icons/weapons/"

-- This has to be done to prevent the game from using the skin's icon
-- while it's equipped on an "incompatible" weapon
function BlackMarketManager:get_weapon_icon_path(weapon_id, cosmetics)
    local texture_path, rarity_path
    
    local use_skin = cosmetics and cosmetics.id and cosmetics.id ~= "nil" and true or false
    local weapon = tweak_data.weapon[weapon_id]
    local skin_id = use_skin and cosmetics.id
    local skin = use_skin and tweak_data.blackmarket.weapon_skins[skin_id]
    
    local is_right_skin
    if use_skin then
        -- Primary and secondary saw share skins
        is_right_skin = ((weapon_id == "saw" or weapon_id == "saw_secondary") and skin.weapon_id == "saw")
        -- Skins for the weapon
        is_right_skin = is_right_skin or (weapon_id == skin.weapon_id)
        -- Show proper skin icon previews while modding/previewing weapon
        if not is_right_skin then
            local open_menus = managers.menu._open_menus
            local open_menu = (#open_menus >= 1) and open_menus[#open_menus]
            local node_name = open_menu and open_menu.logic:selected_node() and open_menu.logic:selected_node_name()
            if node_name == "blackmarket_node" or node_name == "blackmarket_crafting_node" then
                is_right_skin = true
            end
        end
        
        -- Always use skin icon if the related setting is enabled
        is_right_skin = is_right_skin or (sss_settings and sss_settings._data.always_use_skin_icon)
    end
    
    -- Weapon icon
    local guis_catalog = "guis/"
    if use_skin and is_right_skin then
		local bundle_folder = skin.texture_bundle_folder
		if bundle_folder then
            guis_catalog = string.format("%sdlcs/%s/", guis_catalog, bundle_folder)
		end
		texture_path = guis_catalog .. skin_path .. (skin.texture_name or tostring(skin_id))
    else
        local bundle_folder = weapon.texture_bundle_folder
        if bundle_folder then
            guis_catalog = string.format("%sdlcs/%s/", guis_catalog, bundle_folder)
        end
        texture_path = guis_catalog .. icon_path .. (weapon.texture_name or tostring(weapon_id))
    end
    
    -- Rarity texture
    if use_skin then
        local rarity = skin.rarity or "common"
        rarity_path = tweak_data.economy.rarities[rarity] and tweak_data.economy.rarities[rarity].bg_texture
    end
    
    return texture_path, rarity_path
end
