_G.sss_settings = _G.sss_settings or {}

local original_init_weapon_skins = BlackMarketTweakData._init_weapon_skins
function BlackMarketTweakData:_init_weapon_skins(...)
    original_init_weapon_skins(self, ...)

    -- Unlock legendary skins for customization
    if sss_settings._data.legendary_unlocked == true then
        for id, skin in pairs(self.weapon_skins) do
            if skin.rarity == "legendary" then
                skin.locked = false
            end
        end
    end

    -- Remove blueprints(predefined attachments) from all legendary skins
    if sss_settings._data.default_blueprint == true then
        for id, skin in pairs(self.weapon_skins) do
            if skin.rarity == "legendary" and skin.default_blueprint ~= nil then
                skin.default_blueprint = nil
            end
        end
    end

    -- Remove blueprints(predefined attachments) from all skins that have them
    if sss_settings._data.remove_skins_attachments == true then
        for id, skin in pairs(self.weapon_skins) do
            if skin.default_blueprint ~= nil then
                skin.default_blueprint = nil
            end
        end
        -- This is because I hate orange
        self.weapon_skins.x_g22c_waves.types = {
            lower_reciever = {
                base_gradient = Idstring("units/payday2_cash/safes/flake/base_gradient/base_flake_008_b_df")
            }
        }
        self.weapon_skins.x_g22c_waves.parts = {
            wpn_fps_upg_fl_pis_tlr1 = {
                [Idstring("tlr1"):key()] = {
                    base_gradient = Idstring("units/payday2_cash/safes/buck/base_gradient/base_buck_004_df")
                }
            }
        }
    end

    -- Allow using every skin on every weapon
    if sss_settings._data.skin_swapper == true then
        -- Compile the list of weapons
        local weapon_list = {}
        for id, entry in pairs(_G._skinswapper_tweak_data.weapon) do
            -- Double-check if it's a weapon and not some misc junk
            if type(entry)=="table" and type(entry.stats)=="table" then
                table.insert(weapon_list, id)
            end
        end
        for _, skin in pairs(self.weapon_skins) do
            -- Just in case
            if skin.weapon_id == nil and #skin.weapon_ids>0 then skin.weapon_id=skin.weapon_ids[1] end
            -- Give each skin a copy of the weapon table, in the unlikely case someone else wants to tamper with them
            skin.weapon_ids = {unpack(weapon_list)}
        end

        -- The following are to make Custom Akimbos and Weapons without skins work -- 
	self.weapon_skins.new_m14_dallas.weapon_id = "x_basset"
	self.weapon_skins.deagle_dallas.weapon_id = "basset"
	self.weapon_skins.ppk_dallas.weapon_id = "slap"
	self.weapon_skins.ak74_dallas.weapon_id = "pl14"
	self.weapon_skins.r93_dallas.weapon_id = "corgi"
	self.weapon_skins.huntsman_dallas.weapon_id = "ecp"
	self.weapon_skins.flamethrower_mk2_dallas.weapon_id = "x_sr2"
	self.weapon_skins.famas_dallas.weapon_id = "sr2"
	self.weapon_skins.mg42_dallas.weapon_id = "x_packrat"
	self.weapon_skins.deagle_bloodbath.weapon_id = "packrat"
	self.weapon_skins.flamethrower_mk2_bloodbath.weapon_id = "x_shrew"
        self.weapon_skins.judge_bloodbath.weapon_id = "shrew"
        self.weapon_skins.ksg_ginger.weapon_id = "x_olympic"
        self.weapon_skins.ak5_baaah.weapon_id = "x_g17"
        self.weapon_skins.usp_baaah.weapon_id = "x_polymer"
        self.weapon_skins.polymer_baaah.weapon_id = "long"
        self.weapon_skins.m249_baaah.weapon_id = "arblast"
        self.weapon_skins.p90_golddigger.weapon_id = "x_mac10"
        self.weapon_skins.serbu_golddigger.weapon_id = "pl14"
        self.weapon_skins.saiga_ginger.weapon_id = "sub2000"
        self.weapon_skins.wa2000_ginger.weapon_id = "hajk"
        self.weapon_skins.p226_ginger.weapon_id = "x_tec9"
        self.weapon_skins.new_mp5_ginger.weapon_id = "akm_gold"
        self.weapon_skins.m249_ginger.weapon_id = "cobray"
        self.weapon_skins.new_m4_bloodbath.weapon_id = "x_mp9"
        self.weapon_skins.new_raging_bull_dallas.weapon_id = "schakal"
        self.weapon_skins.serbu_woodland.weapon_id = "x_raging"
        self.weapon_skins.p90_woodland.weapon_id = "x_peace"
        self.weapon_skins.plainsrider_woodland.weapon_id = "x_mateba"
        self.weapon_skins.rpg7_woodland.weapon_id = "x_m249"
        self.weapon_skins.ppk_woodland.weapon_id = "x_p90"
        self.weapon_skins.judge_woodland.weapon_id = "x_skorpion"
        self.weapon_skins.new_m4_goldstripes.weapon_id = "x_miniuzi"
        self.weapon_skins.new_raging_bull_goldstripes.weapon_id = "x_m16"
        self.weapon_skins.flamethrower_mk2_goldstripes.weapon_id = "x_m70"
        self.weapon_skins.g36_goldstripes.weapon_id = "x_akm"
        self.weapon_skins.m95_forest.weapon_id = "x_akm_gold"
        self.weapon_skins.famas_forest.weapon_id = "x_ak74"
        self.weapon_skins.huntsman_forest.weapon_id = "x_rpk"
        self.weapon_skins.r93_forest.weapon_id = "x_s12"
        self.weapon_skins.b92fs_forest.weapon_id = "x_ppk"
        self.weapon_skins.m134_forest.weapon_id = "x_beagle"
        self.weapon_skins.new_m14_camohex.weapon_id = "x_pl14"
        self.weapon_skins.judge_camohex.weapon_id = "x_hs2000"
        self.weapon_skins.mg42_camohex.weapon_id = "x_p226"
        self.weapon_skins.new_m14_golddigger.weapon_id = "x_g18"
        self.weapon_skins.ppk_golddigger.weapon_id = "x_huntsman"
        self.weapon_skins.m95_golddigger.weapon_id = "x_judge"
        self.weapon_skins.b92fs_bloodbath.weapon_id = "x_cobray"
        self.weapon_skins.new_raging_bull_bloodbath.weapon_id = "x_aa12"
	   self.weapon_skins.plainsrider_bloodbath.weapon_id = "x_baka"

    end 
end
