_G.sss_settings = _G.sss_settings or {}
sss_settings._path = ModPath
sss_settings._old_data_path = SavePath .. "clsdata.txt"
sss_settings._data_path = SavePath .. "sss_settings.txt"
sss_settings._data = {} 

function sss_settings:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self._data ) )
		file:close()
	end
end

function sss_settings:Load()
	local file = io.open( self._data_path, "r" )
    -- Load settings from older versions of Super Skin Swapper
	file = file or io.open( self._old_data_path, "r" )
	if file then
		self._data = json.decode( file:read("*all") )
		file:close()
	end
end

sss_settings:Load()
if sss_settings._data.legendary_unlocked == nil then
	sss_settings._data.legendary_unlocked = true
	sss_settings:Save()
end

if sss_settings._data.default_blueprint == nil then
	sss_settings._data.default_blueprint = true
	sss_settings:Save()
end

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_sss_settings", function( loc )
	loc:load_localization_file( sss_settings._path .. "Loc/eng.txt")
end)

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_sss_settings", function( menu_manager )
	MenuCallbackHandler.callback_toggle_legendary_unlocked = function(self, item)
		sss_settings._data.legendary_unlocked = (item:value() == "on" and true or false)
		sss_settings:Save()
	end
	MenuCallbackHandler.callback_toggle_default_blueprint = function(self, item)
		sss_settings._data.default_blueprint = (item:value() == "on" and true or false)
		sss_settings:Save()
	end
	MenuCallbackHandler.callback_toggle_remove_skins_attachments = function(self, item)
		sss_settings._data.remove_skins_attachments = (item:value() == "on" and true or false)
		sss_settings:Save()
	end
	MenuCallbackHandler.callback_toggle_skin_swapper = function(self, item)
		sss_settings._data.skin_swapper = (item:value() == "on" and true or false)
		sss_settings:Save()
	end
    
	MenuCallbackHandler.callback_toggle_always_use_skin_icon = function(self, item)
		sss_settings._data.always_use_skin_icon = (item:value() == "on" and true or false)
		sss_settings:Save()
	end

	MenuHelper:LoadFromJsonFile( sss_settings._path .. "Menu/menu.txt", sss_settings, sss_settings._data )
end)
